"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _RandomPoemAPI200Response = _interopRequireDefault(require("../model/RandomPoemAPI200Response"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * API League
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */
/**
* Art service.
* @module api/ArtApi
* @version 1.6.4
*/
var ArtApi = exports["default"] = /*#__PURE__*/function () {
  /**
  * Constructs a new ArtApi. 
  * @alias module:api/ArtApi
  * @class
  * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
  * default to {@link module:ApiClient#instance} if unspecified.
  */
  function ArtApi(apiClient) {
    _classCallCheck(this, ArtApi);
    this.apiClient = apiClient || _ApiClient["default"].instance;
  }

  /**
   * Callback function to receive the result of the imageToAsciiArtByURLAPI operation.
   * @callback module:api/ArtApi~imageToAsciiArtByURLAPICallback
   * @param {String} error Error message, if any.
   * @param {String} data The data returned by the service call.
   * @param {String} response The complete HTTP response.
   */

  /**
   * Image to Ascii Art by URL API
   * Convert an image to ASCII art. You can pass the image URL as a query parameter. The API returns the ASCII art as plain text. This endpoint is using the GET method and an image URL as a query parameter.
   * @param {String} url The URL to the image.
   * @param {Object} opts Optional parameters
   * @param {Number} [width] The maximum width of the image (default 400, max. 500).
   * @param {Number} [height] The maximum height of the image (default 400, max. 500).
   * @param {module:api/ArtApi~imageToAsciiArtByURLAPICallback} callback The callback function, accepting three arguments: error, data, response
   * data is of type: {@link String}
   */
  return _createClass(ArtApi, [{
    key: "imageToAsciiArtByURLAPI",
    value: function imageToAsciiArtByURLAPI(url, opts, callback) {
      opts = opts || {};
      var postBody = null;
      // verify the required parameter 'url' is set
      if (url === undefined || url === null) {
        throw new Error("Missing the required parameter 'url' when calling imageToAsciiArtByURLAPI");
      }
      var pathParams = {};
      var queryParams = {
        'url': url,
        'width': opts['width'],
        'height': opts['height']
      };
      var headerParams = {};
      var formParams = {};
      var authNames = ['apiKey', 'headerApiKey'];
      var contentTypes = [];
      var accepts = ['text/plain'];
      var returnType = 'String';
      return this.apiClient.callApi('/convert-image-to-ascii-txt', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }

    /**
     * Callback function to receive the result of the randomPoemAPI operation.
     * @callback module:api/ArtApi~randomPoemAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/RandomPoemAPI200Response} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Random Poem API
     * Retrieve a random poem by many famous authors. You can filter poem's by length (number of lines).
     * @param {Object} opts Optional parameters
     * @param {Number} [minLines] The minimum number of lines of the poem.
     * @param {Number} [maxLines] The maximum number of lines of the poem.
     * @param {module:api/ArtApi~randomPoemAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/RandomPoemAPI200Response}
     */
  }, {
    key: "randomPoemAPI",
    value: function randomPoemAPI(opts, callback) {
      opts = opts || {};
      var postBody = null;
      var pathParams = {};
      var queryParams = {
        'min-lines': opts['minLines'],
        'max-lines': opts['maxLines']
      };
      var headerParams = {};
      var formParams = {};
      var authNames = ['apiKey', 'headerApiKey'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _RandomPoemAPI200Response["default"];
      return this.apiClient.callApi('/retrieve-random-poem', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }
  }]);
}();