"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _FindSimilarBooksAPI200Response = _interopRequireDefault(require("../model/FindSimilarBooksAPI200Response"));
var _SearchBooksAPI200Response = _interopRequireDefault(require("../model/SearchBooksAPI200Response"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * API League
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */
/**
* Books service.
* @module api/BooksApi
* @version 1.6.4
*/
var BooksApi = exports["default"] = /*#__PURE__*/function () {
  /**
  * Constructs a new BooksApi. 
  * @alias module:api/BooksApi
  * @class
  * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
  * default to {@link module:ApiClient#instance} if unspecified.
  */
  function BooksApi(apiClient) {
    _classCallCheck(this, BooksApi);
    this.apiClient = apiClient || _ApiClient["default"].instance;
  }

  /**
   * Callback function to receive the result of the findSimilarBooksAPI operation.
   * @callback module:api/BooksApi~findSimilarBooksAPICallback
   * @param {String} error Error message, if any.
   * @param {module:model/FindSimilarBooksAPI200Response} data The data returned by the service call.
   * @param {String} response The complete HTTP response.
   */

  /**
   * Find Similar Books API
   * Find books that are similar to the given book (based on a set of over 4 million books). This is useful for recommending books to users based on their reading history or preferences. The response will contain a list of similar books with their title, id, and cover image.
   * @param {Number} id The id of the book to which similar books should be found.
   * @param {Object} opts Optional parameters
   * @param {Number} [number] The number of similar books to return in range [1,100]
   * @param {module:api/BooksApi~findSimilarBooksAPICallback} callback The callback function, accepting three arguments: error, data, response
   * data is of type: {@link module:model/FindSimilarBooksAPI200Response}
   */
  return _createClass(BooksApi, [{
    key: "findSimilarBooksAPI",
    value: function findSimilarBooksAPI(id, opts, callback) {
      opts = opts || {};
      var postBody = null;
      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling findSimilarBooksAPI");
      }
      var pathParams = {};
      var queryParams = {
        'id': id,
        'number': opts['number']
      };
      var headerParams = {};
      var formParams = {};
      var authNames = ['apiKey', 'headerApiKey'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _FindSimilarBooksAPI200Response["default"];
      return this.apiClient.callApi('/list-similar-books', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }

    /**
     * Callback function to receive the result of the searchBooksAPI operation.
     * @callback module:api/BooksApi~searchBooksAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/SearchBooksAPI200Response} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Search Books API
     * Search and filter over 4 million books based on matching a query, the ISBN, rating, and more fields. The query is semantically parsed using our own large ontology. That means you can search paranormal books and the ontology knows that Aliens, Werewolves, Ghosts, and Shapeshifters fall into that category.
     * @param {Object} opts Optional parameters
     * @param {String} [query] The search query.
     * @param {Number} [earliestPublishYear] The books must have been published after this year.
     * @param {Number} [latestPublishYear] The books must have been published before this year.
     * @param {Number} [minRating] The minimum rating the book must have gotten in the interval [0,1].
     * @param {Number} [maxRating] The maximum rating the book must have gotten in the interval [0,1].
     * @param {String} [genres] A comma-separated list of genres. Only books from any of the given genres will be returned.
     * @param {String} [authors] A comma-separated list of author ids or names. Only books from any of the given authors will be returned. You can retrieve author ids from the search authors endpoint. Pass author names is slower and if two authors have the same name you can't disambiguate.
     * @param {String} [isbn] Only the book matching the ISBN-13 will be returned
     * @param {String} [oclc] Only the book matching the OCLC will be returned
     * @param {String} [sort] The sorting criteria (publish-date or rating).
     * @param {String} [sortDirection] Whether to sort ascending or descending (ASC or DESC).
     * @param {Boolean} [groupResults] Whether to group similar editions of the same book.
     * @param {Number} [offset] The number of books to skip in range [0,1000]
     * @param {Number} [number] The number of books to return in range [1,100]
     * @param {module:api/BooksApi~searchBooksAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SearchBooksAPI200Response}
     */
  }, {
    key: "searchBooksAPI",
    value: function searchBooksAPI(opts, callback) {
      opts = opts || {};
      var postBody = null;
      var pathParams = {};
      var queryParams = {
        'query': opts['query'],
        'earliest-publish-year': opts['earliestPublishYear'],
        'latest-publish-year': opts['latestPublishYear'],
        'min-rating': opts['minRating'],
        'max-rating': opts['maxRating'],
        'genres': opts['genres'],
        'authors': opts['authors'],
        'isbn': opts['isbn'],
        'oclc': opts['oclc'],
        'sort': opts['sort'],
        'sort-direction': opts['sortDirection'],
        'group-results': opts['groupResults'],
        'offset': opts['offset'],
        'number': opts['number']
      };
      var headerParams = {};
      var formParams = {};
      var authNames = ['apiKey', 'headerApiKey'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _SearchBooksAPI200Response["default"];
      return this.apiClient.callApi('/search-books', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }
  }]);
}();