"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _RandomQuoteAPI200Response = _interopRequireDefault(require("../model/RandomQuoteAPI200Response"));
var _RandomRiddleAPI200Response = _interopRequireDefault(require("../model/RandomRiddleAPI200Response"));
var _RandomTriviaAPI200Response = _interopRequireDefault(require("../model/RandomTriviaAPI200Response"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * API League
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */
/**
* Knowledge service.
* @module api/KnowledgeApi
* @version 1.6.4
*/
var KnowledgeApi = exports["default"] = /*#__PURE__*/function () {
  /**
  * Constructs a new KnowledgeApi. 
  * @alias module:api/KnowledgeApi
  * @class
  * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
  * default to {@link module:ApiClient#instance} if unspecified.
  */
  function KnowledgeApi(apiClient) {
    _classCallCheck(this, KnowledgeApi);
    this.apiClient = apiClient || _ApiClient["default"].instance;
  }

  /**
   * Callback function to receive the result of the randomQuoteAPI operation.
   * @callback module:api/KnowledgeApi~randomQuoteAPICallback
   * @param {String} error Error message, if any.
   * @param {module:model/RandomQuoteAPI200Response} data The data returned by the service call.
   * @param {String} response The complete HTTP response.
   */

  /**
   * Random Quote API
   * This API returns a random quote from a collection of quotes. The quotes are from famous people and are in English.
   * @param {Object} opts Optional parameters
   * @param {Number} [minLength] The minimum length of the quote in letters.
   * @param {Number} [maxLength] The maximum length of the quote in letters.
   * @param {module:api/KnowledgeApi~randomQuoteAPICallback} callback The callback function, accepting three arguments: error, data, response
   * data is of type: {@link module:model/RandomQuoteAPI200Response}
   */
  return _createClass(KnowledgeApi, [{
    key: "randomQuoteAPI",
    value: function randomQuoteAPI(opts, callback) {
      opts = opts || {};
      var postBody = null;
      var pathParams = {};
      var queryParams = {
        'min-length': opts['minLength'],
        'max-length': opts['maxLength']
      };
      var headerParams = {};
      var formParams = {};
      var authNames = ['apiKey', 'headerApiKey'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _RandomQuoteAPI200Response["default"];
      return this.apiClient.callApi('/retrieve-random-quote', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }

    /**
     * Callback function to receive the result of the randomRiddleAPI operation.
     * @callback module:api/KnowledgeApi~randomRiddleAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/RandomRiddleAPI200Response} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Random Riddle API
     * The riddles API returns a random riddle or brain-teaser. Riddles are a great way to exercise your brain and keep it sharp. The API supports brain-teasers in three difficulty levels: easy, medium, and hard. You can also get a random riddle without specifying a difficulty level.
     * @param {Object} opts Optional parameters
     * @param {String} [difficulty] The difficulty of the riddle, either \"easy\", \"medium\", or \"hard\".
     * @param {module:api/KnowledgeApi~randomRiddleAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/RandomRiddleAPI200Response}
     */
  }, {
    key: "randomRiddleAPI",
    value: function randomRiddleAPI(opts, callback) {
      opts = opts || {};
      var postBody = null;
      var pathParams = {};
      var queryParams = {
        'difficulty': opts['difficulty']
      };
      var headerParams = {};
      var formParams = {};
      var authNames = ['apiKey', 'headerApiKey'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _RandomRiddleAPI200Response["default"];
      return this.apiClient.callApi('/retrieve-random-riddle', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }

    /**
     * Callback function to receive the result of the randomTriviaAPI operation.
     * @callback module:api/KnowledgeApi~randomTriviaAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/RandomTriviaAPI200Response} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Random Trivia API
     * This endpoint returns a random piece of trivia like \"Rio de Janeiro was once the capital of Portugal, making it the only European capital outside of Europe.\".
     * @param {Object} opts Optional parameters
     * @param {Number} [maxLength] The maximum length of the trivia in letters.
     * @param {module:api/KnowledgeApi~randomTriviaAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/RandomTriviaAPI200Response}
     */
  }, {
    key: "randomTriviaAPI",
    value: function randomTriviaAPI(opts, callback) {
      opts = opts || {};
      var postBody = null;
      var pathParams = {};
      var queryParams = {
        'max-length': opts['maxLength']
      };
      var headerParams = {};
      var formParams = {};
      var authNames = ['apiKey', 'headerApiKey'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _RandomTriviaAPI200Response["default"];
      return this.apiClient.callApi('/retrieve-random-trivia', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }
  }]);
}();