"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _ConvertUnitsAPI200Response = _interopRequireDefault(require("../model/ConvertUnitsAPI200Response"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * API League
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */
/**
* Math service.
* @module api/MathApi
* @version 1.6.4
*/
var MathApi = exports["default"] = /*#__PURE__*/function () {
  /**
  * Constructs a new MathApi. 
  * @alias module:api/MathApi
  * @class
  * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
  * default to {@link module:ApiClient#instance} if unspecified.
  */
  function MathApi(apiClient) {
    _classCallCheck(this, MathApi);
    this.apiClient = apiClient || _ApiClient["default"].instance;
  }

  /**
   * Callback function to receive the result of the convertUnitsAPI operation.
   * @callback module:api/MathApi~convertUnitsAPICallback
   * @param {String} error Error message, if any.
   * @param {module:model/ConvertUnitsAPI200Response} data The data returned by the service call.
   * @param {String} response The complete HTTP response.
   */

  /**
   * Convert Units API
   * Convert units from one to another. The API returns the amount and the unit of the target unit.
   * @param {Number} sourceAmount The source amount.
   * @param {String} sourceUnit The source unit.
   * @param {String} targetUnit The unit to which should be converted.
   * @param {Object} opts Optional parameters
   * @param {String} [foodName] An optional food name. For converting foods the food is relevant as they have different densities.
   * @param {module:api/MathApi~convertUnitsAPICallback} callback The callback function, accepting three arguments: error, data, response
   * data is of type: {@link module:model/ConvertUnitsAPI200Response}
   */
  return _createClass(MathApi, [{
    key: "convertUnitsAPI",
    value: function convertUnitsAPI(sourceAmount, sourceUnit, targetUnit, opts, callback) {
      opts = opts || {};
      var postBody = null;
      // verify the required parameter 'sourceAmount' is set
      if (sourceAmount === undefined || sourceAmount === null) {
        throw new Error("Missing the required parameter 'sourceAmount' when calling convertUnitsAPI");
      }
      // verify the required parameter 'sourceUnit' is set
      if (sourceUnit === undefined || sourceUnit === null) {
        throw new Error("Missing the required parameter 'sourceUnit' when calling convertUnitsAPI");
      }
      // verify the required parameter 'targetUnit' is set
      if (targetUnit === undefined || targetUnit === null) {
        throw new Error("Missing the required parameter 'targetUnit' when calling convertUnitsAPI");
      }
      var pathParams = {};
      var queryParams = {
        'source-amount': sourceAmount,
        'source-unit': sourceUnit,
        'target-unit': targetUnit,
        'food-name': opts['foodName']
      };
      var headerParams = {};
      var formParams = {};
      var authNames = ['apiKey', 'headerApiKey'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _ConvertUnitsAPI200Response["default"];
      return this.apiClient.callApi('/convert-units', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }
  }]);
}();