"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _ExtractNewsAPI200Response = _interopRequireDefault(require("../model/ExtractNewsAPI200Response"));
var _SearchNewsAPI200Response = _interopRequireDefault(require("../model/SearchNewsAPI200Response"));
var _TopNewsAPI200Response = _interopRequireDefault(require("../model/TopNewsAPI200Response"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * API League
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */
/**
* News service.
* @module api/NewsApi
* @version 1.6.4
*/
var NewsApi = exports["default"] = /*#__PURE__*/function () {
  /**
  * Constructs a new NewsApi. 
  * @alias module:api/NewsApi
  * @class
  * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
  * default to {@link module:ApiClient#instance} if unspecified.
  */
  function NewsApi(apiClient) {
    _classCallCheck(this, NewsApi);
    this.apiClient = apiClient || _ApiClient["default"].instance;
  }

  /**
   * Callback function to receive the result of the extractNewsAPI operation.
   * @callback module:api/NewsApi~extractNewsAPICallback
   * @param {String} error Error message, if any.
   * @param {module:model/ExtractNewsAPI200Response} data The data returned by the service call.
   * @param {String} response The complete HTTP response.
   */

  /**
   * Extract News API
   * Extract a news article from a website to a well structure JSON object. The API will return the title, text, URL, image, publish date, author, language, source country, and sentiment of the news article.
   * @param {String} url The url of the news.
   * @param {Boolean} analyze Whether to analyze the news (extract entities etc.)
   * @param {module:api/NewsApi~extractNewsAPICallback} callback The callback function, accepting three arguments: error, data, response
   * data is of type: {@link module:model/ExtractNewsAPI200Response}
   */
  return _createClass(NewsApi, [{
    key: "extractNewsAPI",
    value: function extractNewsAPI(url, analyze, callback) {
      var postBody = null;
      // verify the required parameter 'url' is set
      if (url === undefined || url === null) {
        throw new Error("Missing the required parameter 'url' when calling extractNewsAPI");
      }
      // verify the required parameter 'analyze' is set
      if (analyze === undefined || analyze === null) {
        throw new Error("Missing the required parameter 'analyze' when calling extractNewsAPI");
      }
      var pathParams = {};
      var queryParams = {
        'url': url,
        'analyze': analyze
      };
      var headerParams = {};
      var formParams = {};
      var authNames = ['apiKey', 'headerApiKey'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _ExtractNewsAPI200Response["default"];
      return this.apiClient.callApi('/extract-news', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }

    /**
     * Callback function to receive the result of the searchNewsAPI operation.
     * @callback module:api/NewsApi~searchNewsAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/SearchNewsAPI200Response} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Search News API
     * Search and filter millions of news from over 200 countries in 90 languages by text, date, location, category, language, and more. The API returns a list of news articles matching the given criteria. You can set as many filtering parameters as you like, but you have to set at least one, e.g. text or language.
     * @param {Object} opts Optional parameters
     * @param {String} [text] The text to match in the news content (at least 3 characters, maximum 100 characters). By default all query terms are expected, you can use an uppercase OR to search for any terms, e.g. tesla OR ford. You can also exclude terms by putting a minus sign (-) in front of the term, e.g. tesla -ford.
     * @param {String} [sourceCountries] A comma-separated list of ISO 3166 country codes from which the news should originate.
     * @param {String} [language] The ISO 6391 language code of the news.
     * @param {Number} [minSentiment] The minimal sentiment of the news in range [-1,1].
     * @param {Number} [maxSentiment] The maximal sentiment of the news in range [-1,1].
     * @param {String} [earliestPublishDate] The news must have been published after this date.
     * @param {String} [latestPublishDate] The news must have been published before this date.
     * @param {String} [newsSources] A comma-separated list of news sources from which the news should originate.
     * @param {String} [authors] A comma-separated list of author names. Only news from any of the given authors will be returned.
     * @param {String} [categories] A comma-separated list of categories. Only news from any of the given categories will be returned. Possible categories are politics, sports, business, technology, entertainment, health, science, lifestyle, travel, culture, education, environment, other.
     * @param {String} [entities] Filter news by entities (ORG, PER, or LOC).
     * @param {String} [locationFilter] Filter news by radius around a certain location. Format is \"latitude,longitude,radius in kilometers\"
     * @param {String} [sort] The sorting criteria (publish-time).
     * @param {String} [sortDirection] Whether to sort ascending or descending (ASC or DESC).
     * @param {Number} [offset] The number of news to skip in range [0,10000]
     * @param {Number} [number] The number of news to return in range [1,100]
     * @param {module:api/NewsApi~searchNewsAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SearchNewsAPI200Response}
     */
  }, {
    key: "searchNewsAPI",
    value: function searchNewsAPI(opts, callback) {
      opts = opts || {};
      var postBody = null;
      var pathParams = {};
      var queryParams = {
        'text': opts['text'],
        'source-countries': opts['sourceCountries'],
        'language': opts['language'],
        'min-sentiment': opts['minSentiment'],
        'max-sentiment': opts['maxSentiment'],
        'earliest-publish-date': opts['earliestPublishDate'],
        'latest-publish-date': opts['latestPublishDate'],
        'news-sources': opts['newsSources'],
        'authors': opts['authors'],
        'categories': opts['categories'],
        'entities': opts['entities'],
        'location-filter': opts['locationFilter'],
        'sort': opts['sort'],
        'sort-direction': opts['sortDirection'],
        'offset': opts['offset'],
        'number': opts['number']
      };
      var headerParams = {};
      var formParams = {};
      var authNames = ['apiKey', 'headerApiKey'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _SearchNewsAPI200Response["default"];
      return this.apiClient.callApi('/search-news', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }

    /**
     * Callback function to receive the result of the topNewsAPI operation.
     * @callback module:api/NewsApi~topNewsAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/TopNewsAPI200Response} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Top News API
     * Get the top news from a country (over 220 are supported) in a language (over 90 are supported) for a specific date. The top news are clustered from multiple sources in the given country. The more news in a cluster the higher the cluster is ranked.
     * @param {String} sourceCountry The ISO 3166 country code of the country for which top news should be retrieved.
     * @param {String} language The ISO 6391 language code of the top news. The language must be one spoken in the source-country.
     * @param {Object} opts Optional parameters
     * @param {String} [date] The date for which the top news should be retrieved. If no date is given, the current day is assumed.
     * @param {Boolean} [headlinesOnly] Whether to only return basic information such as id, title, and url of the news.
     * @param {module:api/NewsApi~topNewsAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TopNewsAPI200Response}
     */
  }, {
    key: "topNewsAPI",
    value: function topNewsAPI(sourceCountry, language, opts, callback) {
      opts = opts || {};
      var postBody = null;
      // verify the required parameter 'sourceCountry' is set
      if (sourceCountry === undefined || sourceCountry === null) {
        throw new Error("Missing the required parameter 'sourceCountry' when calling topNewsAPI");
      }
      // verify the required parameter 'language' is set
      if (language === undefined || language === null) {
        throw new Error("Missing the required parameter 'language' when calling topNewsAPI");
      }
      var pathParams = {};
      var queryParams = {
        'source-country': sourceCountry,
        'language': language,
        'date': opts['date'],
        'headlines-only': opts['headlinesOnly']
      };
      var headerParams = {};
      var formParams = {};
      var authNames = ['apiKey', 'headerApiKey'];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = _TopNewsAPI200Response["default"];
      return this.apiClient.callApi('/retrieve-top-news', 'GET', pathParams, queryParams, headerParams, formParams, postBody, authNames, contentTypes, accepts, returnType, null, callback);
    }
  }]);
}();