"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _ScoreTextAPI200ResponseInterestingness = _interopRequireDefault(require("./ScoreTextAPI200ResponseInterestingness"));
var _ScoreTextAPI200ResponseReadability = _interopRequireDefault(require("./ScoreTextAPI200ResponseReadability"));
var _ScoreTextAPI200ResponseSkimmability = _interopRequireDefault(require("./ScoreTextAPI200ResponseSkimmability"));
var _ScoreTextAPI200ResponseStyle = _interopRequireDefault(require("./ScoreTextAPI200ResponseStyle"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } /**
 * API League
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */
/**
 * The ScoreTextAPI200Response model module.
 * @module model/ScoreTextAPI200Response
 * @version 1.6.4
 */
var ScoreTextAPI200Response = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ScoreTextAPI200Response</code>.
   * @alias module:model/ScoreTextAPI200Response
   */
  function ScoreTextAPI200Response() {
    _classCallCheck(this, ScoreTextAPI200Response);
    ScoreTextAPI200Response.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  return _createClass(ScoreTextAPI200Response, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>ScoreTextAPI200Response</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ScoreTextAPI200Response} obj Optional instance to populate.
     * @return {module:model/ScoreTextAPI200Response} The populated <code>ScoreTextAPI200Response</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ScoreTextAPI200Response();
        if (data.hasOwnProperty('number_of_words')) {
          obj['number_of_words'] = _ApiClient["default"].convertToType(data['number_of_words'], 'Number');
        }
        if (data.hasOwnProperty('number_of_sentences')) {
          obj['number_of_sentences'] = _ApiClient["default"].convertToType(data['number_of_sentences'], 'Number');
        }
        if (data.hasOwnProperty('readability')) {
          obj['readability'] = _ScoreTextAPI200ResponseReadability["default"].constructFromObject(data['readability']);
        }
        if (data.hasOwnProperty('skimmability')) {
          obj['skimmability'] = _ScoreTextAPI200ResponseSkimmability["default"].constructFromObject(data['skimmability']);
        }
        if (data.hasOwnProperty('interestingness')) {
          obj['interestingness'] = _ScoreTextAPI200ResponseInterestingness["default"].constructFromObject(data['interestingness']);
        }
        if (data.hasOwnProperty('style')) {
          obj['style'] = _ScoreTextAPI200ResponseStyle["default"].constructFromObject(data['style']);
        }
        if (data.hasOwnProperty('total_score')) {
          obj['total_score'] = _ApiClient["default"].convertToType(data['total_score'], 'Number');
        }
      }
      return obj;
    }

    /**
     * Validates the JSON data with respect to <code>ScoreTextAPI200Response</code>.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @return {boolean} to indicate whether the JSON data is valid with respect to <code>ScoreTextAPI200Response</code>.
     */
  }, {
    key: "validateJSON",
    value: function validateJSON(data) {
      // validate the optional field `readability`
      if (data['readability']) {
        // data not null
        _ScoreTextAPI200ResponseReadability["default"].validateJSON(data['readability']);
      }
      // validate the optional field `skimmability`
      if (data['skimmability']) {
        // data not null
        _ScoreTextAPI200ResponseSkimmability["default"].validateJSON(data['skimmability']);
      }
      // validate the optional field `interestingness`
      if (data['interestingness']) {
        // data not null
        _ScoreTextAPI200ResponseInterestingness["default"].validateJSON(data['interestingness']);
      }
      // validate the optional field `style`
      if (data['style']) {
        // data not null
        _ScoreTextAPI200ResponseStyle["default"].validateJSON(data['style']);
      }
      return true;
    }
  }]);
}();
/**
 * @member {Number} number_of_words
 */
ScoreTextAPI200Response.prototype['number_of_words'] = undefined;

/**
 * @member {Number} number_of_sentences
 */
ScoreTextAPI200Response.prototype['number_of_sentences'] = undefined;

/**
 * @member {module:model/ScoreTextAPI200ResponseReadability} readability
 */
ScoreTextAPI200Response.prototype['readability'] = undefined;

/**
 * @member {module:model/ScoreTextAPI200ResponseSkimmability} skimmability
 */
ScoreTextAPI200Response.prototype['skimmability'] = undefined;

/**
 * @member {module:model/ScoreTextAPI200ResponseInterestingness} interestingness
 */
ScoreTextAPI200Response.prototype['interestingness'] = undefined;

/**
 * @member {module:model/ScoreTextAPI200ResponseStyle} style
 */
ScoreTextAPI200Response.prototype['style'] = undefined;

/**
 * @member {Number} total_score
 */
ScoreTextAPI200Response.prototype['total_score'] = undefined;
var _default = exports["default"] = ScoreTextAPI200Response;