/**
 * API League
 * API League is a Hub for World Class APIs.
 *
 * The version of the OpenAPI document: 1.6.4
 * Contact: mail@apileague.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import GenerateNonsenseWordAPI200Response from '../model/GenerateNonsenseWordAPI200Response';
import RandomMemeAPI200Response from '../model/RandomMemeAPI200Response';
import SearchGifsAPI200Response from '../model/SearchGifsAPI200Response';
import SearchJokesAPI200Response from '../model/SearchJokesAPI200Response';
import SearchJokesAPI200ResponseJokesInner from '../model/SearchJokesAPI200ResponseJokesInner';
import SearchMemesAPI200Response from '../model/SearchMemesAPI200Response';

/**
* Humor service.
* @module api/HumorApi
* @version 1.6.4
*/
export default class HumorApi {

    /**
    * Constructs a new HumorApi. 
    * @alias module:api/HumorApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }


    /**
     * Callback function to receive the result of the generateNonsenseWordAPI operation.
     * @callback module:api/HumorApi~generateNonsenseWordAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/GenerateNonsenseWordAPI200Response} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Generate Nonsense Word API
     * Generate a funny sounding nonsense word. This is useful for generating random words for games, naming things, or just for fun. The response will contain the generated word and a rating of how funny it is.
     * @param {module:api/HumorApi~generateNonsenseWordAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GenerateNonsenseWordAPI200Response}
     */
    generateNonsenseWordAPI(callback) {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['apiKey', 'headerApiKey'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = GenerateNonsenseWordAPI200Response;
      return this.apiClient.callApi(
        '/generate-nonsense-word', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the randomJokeAPI operation.
     * @callback module:api/HumorApi~randomJokeAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/SearchJokesAPI200ResponseJokesInner} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Random Joke API
     * This is a simple API that returns a random joke. You can filter the jokes by tags and keywords. To make sure they are safe for work, you could use the exclude-tags parameter to exclude jokes with certain tags such as \"nsfw\" or \"religious\".
     * @param {Object} opts Optional parameters
     * @param {String} [includeTags] A comma-separated list of tags the jokes should have.
     * @param {String} [excludeTags] A comma-separated list of tags the jokes must not have.
     * @param {Number} [minRating] The minimum rating in range [0.0,1.0] of the jokes.
     * @param {Number} [maxLength] The maximum length of the joke in letters.
     * @param {module:api/HumorApi~randomJokeAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SearchJokesAPI200ResponseJokesInner}
     */
    randomJokeAPI(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'include-tags': opts['includeTags'],
        'exclude-tags': opts['excludeTags'],
        'min-rating': opts['minRating'],
        'max-length': opts['maxLength']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['apiKey', 'headerApiKey'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = SearchJokesAPI200ResponseJokesInner;
      return this.apiClient.callApi(
        '/retrieve-random-joke', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the randomMemeAPI operation.
     * @callback module:api/HumorApi~randomMemeAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/RandomMemeAPI200Response} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Random Meme API
     * Get a random meme out of over 300,000+ memes. To get the latest memes, you can use the max-age-days parameter.
     * @param {Object} opts Optional parameters
     * @param {String} [keywords] A comma-separated list of words that must occur in the meme.
     * @param {Boolean} [keywordsInImage] Whether the keywords must occur in the image.
     * @param {String} [mediaType] The media type (either 'image', 'video' or even specific format such as 'jpg', 'png', or 'gif').
     * @param {Number} [minRating] The minimum rating in range [0.0,1.0] of the meme.
     * @param {Number} [maxAgeDays] The maximum age of the meme in days.
     * @param {module:api/HumorApi~randomMemeAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/RandomMemeAPI200Response}
     */
    randomMemeAPI(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'keywords': opts['keywords'],
        'keywords-in-image': opts['keywordsInImage'],
        'media-type': opts['mediaType'],
        'min-rating': opts['minRating'],
        'max-age-days': opts['maxAgeDays']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['apiKey', 'headerApiKey'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = RandomMemeAPI200Response;
      return this.apiClient.callApi(
        '/retrieve-random-meme', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the searchGifsAPI operation.
     * @callback module:api/HumorApi~searchGifsAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/SearchGifsAPI200Response} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Search Gifs API
     * Search through hundreds of thousands of gifs to match any reaction you want. The gifs are returned in a list with the URL, width, and height of the gif.
     * @param {String} query The search query.
     * @param {Object} opts Optional parameters
     * @param {Number} [number] The number of gifs to return in range [1,10]
     * @param {module:api/HumorApi~searchGifsAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SearchGifsAPI200Response}
     */
    searchGifsAPI(query, opts, callback) {
      opts = opts || {};
      let postBody = null;
      // verify the required parameter 'query' is set
      if (query === undefined || query === null) {
        throw new Error("Missing the required parameter 'query' when calling searchGifsAPI");
      }

      let pathParams = {
      };
      let queryParams = {
        'query': query,
        'number': opts['number']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['apiKey', 'headerApiKey'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = SearchGifsAPI200Response;
      return this.apiClient.callApi(
        '/search-gifs', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the searchJokesAPI operation.
     * @callback module:api/HumorApi~searchJokesAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/SearchJokesAPI200Response} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Search Jokes API
     * With over 50,000 jokes, you should find something for any occasion. There are 27 categories/tags to choose from, but you can also search for very specific words within jokes.
     * @param {Object} opts Optional parameters
     * @param {String} [keywords] A comma-separated list of words that must occur in the joke.
     * @param {String} [includeTags] A comma-separated list of tags the jokes should have.
     * @param {String} [excludeTags] A comma-separated list of tags the jokes must not have.
     * @param {Number} [minRating] The minimum rating in range [0.0,1.0] of the jokes.
     * @param {Number} [maxLength] The maximum length of the joke in letters.
     * @param {Number} [offset] The number of jokes to skip, between 0 and 1000.
     * @param {Number} [number] The number of jokes, between 1 and 10.
     * @param {module:api/HumorApi~searchJokesAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SearchJokesAPI200Response}
     */
    searchJokesAPI(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'keywords': opts['keywords'],
        'include-tags': opts['includeTags'],
        'exclude-tags': opts['excludeTags'],
        'min-rating': opts['minRating'],
        'max-length': opts['maxLength'],
        'offset': opts['offset'],
        'number': opts['number']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['apiKey', 'headerApiKey'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = SearchJokesAPI200Response;
      return this.apiClient.callApi(
        '/search-jokes', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }

    /**
     * Callback function to receive the result of the searchMemesAPI operation.
     * @callback module:api/HumorApi~searchMemesAPICallback
     * @param {String} error Error message, if any.
     * @param {module:model/SearchMemesAPI200Response} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Search Memes API
     * Search over 300,000 memes by keyword, rating, and age. Most memes are stills (images) but using the media-type you can also get videos. You can even search for text within memes. You'll surely find something funny.
     * @param {Object} opts Optional parameters
     * @param {String} [keywords] A comma-separated list of words that must occur in the meme.
     * @param {Boolean} [keywordsInImage] Whether the keywords must occur in the image.
     * @param {String} [mediaType] The media type (either 'image', 'video' or even specific format such as 'jpg', 'png', or 'gif').
     * @param {Number} [minRating] The minimum rating in range [0.0,1.0] of the meme.
     * @param {Number} [maxAgeDays] The maximum age of the meme in days.
     * @param {Number} [offset] The number of memes to skip, between 0 and 1000.
     * @param {Number} [number] The number of memes, between 1 and 10.
     * @param {module:api/HumorApi~searchMemesAPICallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SearchMemesAPI200Response}
     */
    searchMemesAPI(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'keywords': opts['keywords'],
        'keywords-in-image': opts['keywordsInImage'],
        'media-type': opts['mediaType'],
        'min-rating': opts['minRating'],
        'max-age-days': opts['maxAgeDays'],
        'offset': opts['offset'],
        'number': opts['number']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['apiKey', 'headerApiKey'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = SearchMemesAPI200Response;
      return this.apiClient.callApi(
        '/search-memes', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null, callback
      );
    }


}
